﻿// <auto-generated />
using System;
using AirCompanyApi.DataBase;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

namespace AirCompanyApi.Migrations
{
    [DbContext(typeof(AirCompanyContext))]
    partial class AirCompanyContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("Relational:MaxIdentifierLength", 63)
                .HasAnnotation("ProductVersion", "5.0.8")
                .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn);

            modelBuilder.Entity("AirCompanyApi.Models.Aircraft", b =>
                {
                    b.Property<int>("AircraftId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn);

                    b.Property<string>("BoardNumber")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<bool>("IsFree")
                        .HasColumnType("boolean");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text");

                    b.HasKey("AircraftId");

                    b.ToTable("AirCrafts");
                });

            modelBuilder.Entity("AirCompanyApi.Models.Direction", b =>
                {
                    b.Property<int>("DirectionId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn);

                    b.Property<string>("ArrivalCity")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<DateTime>("ArrivalTime")
                        .HasColumnType("timestamp without time zone");

                    b.Property<string>("DepartureCity")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<DateTime>("DepartureTime")
                        .HasColumnType("timestamp without time zone");

                    b.Property<int>("FlightId")
                        .HasColumnType("integer");

                    b.Property<int>("QuantityPax")
                        .HasColumnType("integer");

                    b.HasKey("DirectionId");

                    b.HasIndex("FlightId");

                    b.ToTable("Direction");
                });

            modelBuilder.Entity("AirCompanyApi.Models.Employee", b =>
                {
                    b.Property<int>("EmployeeId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn);

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<int?>("FlightId")
                        .HasColumnType("integer");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("Password")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("Surname")
                        .IsRequired()
                        .HasColumnType("text");

                    b.HasKey("EmployeeId");

                    b.HasIndex("FlightId");

                    b.ToTable("Employees");

                    b.HasData(
                        new
                        {
                            EmployeeId = 1,
                            Email = "pupkin@gmail.com",
                            Name = "Василий",
                            Password = "123456",
                            Surname = "Пупкин"
                        });
                });

            modelBuilder.Entity("AirCompanyApi.Models.Flight", b =>
                {
                    b.Property<int>("FlightId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn);

                    b.Property<int?>("AircraftId")
                        .HasColumnType("integer");

                    b.Property<string>("Comment")
                        .HasColumnType("text");

                    b.Property<string>("Customer")
                        .HasColumnType("text");

                    b.Property<decimal>("Price")
                        .HasColumnType("numeric");

                    b.HasKey("FlightId");

                    b.HasIndex("AircraftId");

                    b.ToTable("Flights");
                });

            modelBuilder.Entity("AirCompanyApi.Models.Role", b =>
                {
                    b.Property<int>("RoleId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn);

                    b.Property<bool>("CanManageAircraft")
                        .HasColumnType("boolean");

                    b.Property<bool>("CanManageEmployee")
                        .HasColumnType("boolean");

                    b.Property<bool>("CanManageFlight")
                        .HasColumnType("boolean");

                    b.Property<bool>("CanManageRole")
                        .HasColumnType("boolean");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<bool>("SeeCrew")
                        .HasColumnType("boolean");

                    b.Property<bool>("SeeFlightAirCraft")
                        .HasColumnType("boolean");

                    b.Property<bool>("SeeFlightComment")
                        .HasColumnType("boolean");

                    b.Property<bool>("SeeFlightCustomer")
                        .HasColumnType("boolean");

                    b.Property<bool>("SeeFlightDirections")
                        .HasColumnType("boolean");

                    b.Property<bool>("SeeFlightPrice")
                        .HasColumnType("boolean");

                    b.Property<bool>("SeeFlightQuantityPax")
                        .HasColumnType("boolean");

                    b.HasKey("RoleId");

                    b.ToTable("Roles");

                    b.HasData(
                        new
                        {
                            RoleId = 1,
                            CanManageAircraft = false,
                            CanManageEmployee = true,
                            CanManageFlight = false,
                            CanManageRole = true,
                            Name = "Администратор",
                            SeeCrew = false,
                            SeeFlightAirCraft = false,
                            SeeFlightComment = false,
                            SeeFlightCustomer = false,
                            SeeFlightDirections = false,
                            SeeFlightPrice = false,
                            SeeFlightQuantityPax = false
                        });
                });

            modelBuilder.Entity("EmployeeRole", b =>
                {
                    b.Property<int>("EmployeesEmployeeId")
                        .HasColumnType("integer");

                    b.Property<int>("RolesRoleId")
                        .HasColumnType("integer");

                    b.HasKey("EmployeesEmployeeId", "RolesRoleId");

                    b.HasIndex("RolesRoleId");

                    b.ToTable("EmployeeRole");
                });

            modelBuilder.Entity("AirCompanyApi.Models.Direction", b =>
                {
                    b.HasOne("AirCompanyApi.Models.Flight", "Flight")
                        .WithMany("Directions")
                        .HasForeignKey("FlightId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Flight");
                });

            modelBuilder.Entity("AirCompanyApi.Models.Employee", b =>
                {
                    b.HasOne("AirCompanyApi.Models.Flight", null)
                        .WithMany("Crew")
                        .HasForeignKey("FlightId");
                });

            modelBuilder.Entity("AirCompanyApi.Models.Flight", b =>
                {
                    b.HasOne("AirCompanyApi.Models.Aircraft", "Aircraft")
                        .WithMany()
                        .HasForeignKey("AircraftId");

                    b.Navigation("Aircraft");
                });

            modelBuilder.Entity("EmployeeRole", b =>
                {
                    b.HasOne("AirCompanyApi.Models.Employee", null)
                        .WithMany()
                        .HasForeignKey("EmployeesEmployeeId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("AirCompanyApi.Models.Role", null)
                        .WithMany()
                        .HasForeignKey("RolesRoleId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("AirCompanyApi.Models.Flight", b =>
                {
                    b.Navigation("Crew");

                    b.Navigation("Directions");
                });
#pragma warning restore 612, 618
        }
    }
}
